﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace BlinkCell
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //Initialaize c1TrueDBGrid1 to display blinking cells based on the content of the cell itself.
            c1TrueDBGrid1.DataSource = GetDataTable1();
            timer1.Tick += new EventHandler(timer1_Tick);
            timer1.Interval = 200;
            timer1.Start();

            //Initialaize c1TrueDBGrid2 to display blinking cells based on the content of any other cell in grid.
            c1TrueDBGrid2.DataSource = GetDataTable2();
            c1TrueDBGrid2.Splits[0].DisplayColumns[2].FetchStyle = true;
            c1TrueDBGrid2.FetchCellStyle += c1TrueDBGrid2_FetchCellStyle;
            timer2.Interval = 200;
            timer2.Tick += new EventHandler(timer2_Tick);
            timer2.Start();
        }

        //Code to display blinking cells based on the content of the cell itself.
        public DataTable GetDataTable1()
        {
            DataTable dt = new DataTable();
            DataColumn dc1 = new DataColumn("ID");
            DataColumn dc2 = new DataColumn("VALUE");
            DataColumn dc3 = new DataColumn("BLINK");
            dt.Columns.Add(dc1);
            dt.Columns.Add(dc2);
            dt.Columns.Add(dc3);
            for (int r = 1; r <= 5; r++)
            {
                DataRow dr = dt.NewRow();
                dr[0] = r;
                dr[1] = "Value" + r.ToString();
                if (r % 2 == 0)
                    dr[2] = "Y";
                else
                    dr[2] = "N";
                dt.Rows.Add(dr);
            }
            return dt;
        }

        bool bblink = false;

        void timer1_Tick(object sender, EventArgs e)
        {
            if (bblink)
            {
                C1.Win.C1TrueDBGrid.Style S1 = new C1.Win.C1TrueDBGrid.Style();
                S1.BackColor = Color.Red;
                this.c1TrueDBGrid1.Splits[0].DisplayColumns[2].AddRegexCellStyle(C1.Win.C1TrueDBGrid.CellStyleFlag.AllCells, S1, "Y");
            }
            else
            {
                C1.Win.C1TrueDBGrid.Style S2 = new C1.Win.C1TrueDBGrid.Style();
                S2.BackColor = Color.White;
                this.c1TrueDBGrid1.Splits[0].DisplayColumns[2].AddRegexCellStyle(C1.Win.C1TrueDBGrid.CellStyleFlag.AllCells, S2, "Y");
            }
            bblink = !bblink;
        }

        //Code to display blinking cells based on the content of any other cell in grid.
        public DataTable GetDataTable2()
        {
            DataTable dTable = new DataTable();
            dTable.Columns.Add("ID", typeof(int));
            dTable.Columns.Add("Quantity", typeof(int));
            dTable.Columns.Add("Name");
            
            DataRow dr = dTable.NewRow();
            dr.ItemArray = new Object[] {1, 1000, "Quantity1"};
            dTable.Rows.Add(dr);

            dr = dTable.NewRow();
            dr.ItemArray = new Object[] {2, 800, "Quantity2"};
            dTable.Rows.Add(dr);

            dr = dTable.NewRow();
            dr.ItemArray = new Object[] {3, 300, "Quantity3"};
            dTable.Rows.Add(dr);

            dr = dTable.NewRow();
            dr.ItemArray = new Object[] {4, 350, "Quantity4"};
            dTable.Rows.Add(dr);

            dr = dTable.NewRow();
            dr.ItemArray = new Object[] {5, 200, "Quantity5"};
            dTable.Rows.Add(dr);

            return dTable;
        }

        void c1TrueDBGrid2_FetchCellStyle(object sender, C1.Win.C1TrueDBGrid.FetchCellStyleEventArgs e)
        {
            System.Data.DataRowView dr = (System.Data.DataRowView)this.c1TrueDBGrid2[this.c1TrueDBGrid2.RowBookmark(e.Row)];
            if ((int)dr[1] <= 300)
                e.CellStyle.BackColor = Color.Blue;
        }
        void timer2_Tick(object sender, EventArgs e)
        {
            c1TrueDBGrid2.Splits[0].DisplayColumns[2].FetchStyle = !c1TrueDBGrid2.Splits[0].DisplayColumns[2].FetchStyle;
        }
    }
}
